package com.link.core.converter.i18n;

import java.util.ResourceBundle;

public abstract class ResourcesAssist implements BaseResources {
   private ResourceBundle resourceBundle = null;

   public ResourceBundle getResourceBundle() {
      return this.resourceBundle;
   }

   void setResourceBundle(ResourceBundle resourceBundle) {
      this.resourceBundle = resourceBundle;
   }

   public String getResource(String key) {
      return ensureValue(this.resourceBundle, key);
   }

   private static String ensureValue(ResourceBundle bundle, String key) {
      if (bundle == null) {
         return key;
      } else if (!bundle.containsKey(key)) {
         return key;
      } else {
         String value = bundle.getString(key);
         StringBuffer sb = new StringBuffer();
         char last = 0;

         for(int index = 0; index < value.length(); ++index) {
            char ch = value.charAt(index);
            if (ch == '"' && index != 0 && last == '\\') {
               sb.deleteCharAt(index - 1);
            }

            sb.append(ch);
            last = ch;
         }

         return sb.toString();
      }
   }
}
